

option explicit 
#define UNICODE
#include once "windows.bi" 
#include "disphelper/disphelper.bi"

#include "sapi4.bi"
#include "resource.bi"

declare Function DlgProc (byval hwnd as HWND, byval umsg as UINT, byval wparam as WPARAM, byval lparam as LPARAM) as BOOL
                          
' Globals
dim SHARED 	   as IDispatch ptr tts = NULL
	dhInitialize( TRUE )
	dhToggleExceptions( TRUE )


    DialogBoxParam( GetModuleHandle( NULL ), cptr( LPCSTR, IDD_DLG1 ), NULL, @DlgProc, NULL ) 
	SAFE_RELEASE( tts)
	dhUninitialize( TRUE )
    end 
' Program end 

                                 
Function DlgProc (byval hwnd as HWND, byval umsg as UINT, byval wparam as WPARAM, byval lparam as LPARAM) as BOOL
    dim as long id, event
    
    select case uMsg
    case WM_INITDIALOG
 If TRUE <> SAPI4_Initialize(tts) Then
    	EndDialog( hwnd, 0 ) 
Return TRUE
End If
SAPI4_GetVoices(tts, GetDlgItem(hWnd, IDC_VOICES_LIST))
SAPI4_SelectVoice (tts, 1)
SAPI4_SetSpeed (tts, 80)


        
    case WM_CLOSE
    	EndDialog( hwnd, 0 ) 

    case WM_COMMAND
		id    = loword( wParam )
		event = hiword( wParam )

        select case id
        case IDOK 
scope
DIM szBuf AS WSTRING * 1024
GetDlgItemText(hWnd, IDC_TEXT_TO_SPEAK, szBuf, 1024)
SAPI4_Speak (tts, @szBuf)
End Scope

case IDCANCEL
        	EndDialog( hwnd, 0 )

case IDC_VOICES_LIST:
If (event = CBN_SELCHANGE) Then
SAPI4_SelectVoice (tts, SendDlgItemMessage (hWnd, Id, CB_GETCURSEL, 0, 0)+1)
End If

    	end select
        
    case else
    	return FALSE
    
    end select
    
   return TRUE
end function 

